Index: kernel/generic/include/mm/km.h
===================================================================
--- kernel/generic/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/generic/include/mm/km.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericmm
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_KM_H_
+#define KERN_KM_H_
+
+#include <typedefs.h>
+#include <mm/frame.h>
+
+extern void km_identity_init(void);
+extern void km_non_identity_init(void);
+
+extern void km_non_identity_span_add(uintptr_t, size_t);
+
+extern uintptr_t km_page_alloc(size_t, size_t);
+extern void km_page_free(uintptr_t, size_t);
+
+extern bool km_is_non_identity(uintptr_t);
+
+extern uintptr_t km_map(uintptr_t, size_t, unsigned int);
+extern void km_unmap(uintptr_t, size_t);
+
+extern uintptr_t km_temporary_page_get(uintptr_t *, frame_flags_t);
+extern void km_temporary_page_put(uintptr_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/mm/page.h
===================================================================
--- kernel/generic/include/mm/page.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/mm/page.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -49,4 +49,5 @@
 	void (* mapping_remove)(as_t *, uintptr_t);
 	pte_t *(* mapping_find)(as_t *, uintptr_t, bool);
+	void (* mapping_make_global)(uintptr_t, size_t);
 } page_mapping_operations_t;
 
@@ -60,11 +61,10 @@
 extern void page_mapping_remove(as_t *, uintptr_t);
 extern pte_t *page_mapping_find(as_t *, uintptr_t, bool);
+extern void page_mapping_make_global(uintptr_t, size_t);
 extern pte_t *page_table_create(unsigned int);
 extern void page_table_destroy(pte_t *);
-extern void map_structure(uintptr_t, size_t);
 
-extern uintptr_t hw_map(uintptr_t, size_t);
-
-extern sysarg_t sys_page_find_mapping(uintptr_t, uintptr_t *);
+extern int page_find_mapping(uintptr_t, void **);
+extern sysarg_t sys_page_find_mapping(uintptr_t, void *);
 
 #endif
Index: kernel/generic/include/synch/smc.h
===================================================================
--- kernel/generic/include/synch/smc.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/synch/smc.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -36,5 +36,5 @@
 #define KERN_SMC_H_
 
-extern sysarg_t sys_smc_coherence(uintptr_t va, size_t size);
+extern sysarg_t sys_smc_coherence(uintptr_t, size_t);
 
 #endif
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/syscall/syscall.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -45,5 +45,5 @@
 extern sysarg_t syscall_handler(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
-extern sysarg_t sys_tls_set(sysarg_t);
+extern sysarg_t sys_tls_set(uintptr_t);
 
 #endif
Index: kernel/generic/src/cpu/cpu.c
===================================================================
--- kernel/generic/src/cpu/cpu.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/cpu/cpu.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -74,5 +74,5 @@
 		for (i = 0; i < config.cpu_count; i++) {
 			cpus[i].stack = (uint8_t *) frame_alloc(STACK_FRAMES,
-			    FRAME_KA | FRAME_ATOMIC);
+			    FRAME_LOWMEM | FRAME_KA | FRAME_ATOMIC);
 			cpus[i].id = i;
 			
Index: kernel/generic/src/ddi/ddi.c
===================================================================
--- kernel/generic/src/ddi/ddi.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/ddi/ddi.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -45,4 +45,5 @@
 #include <mm/frame.h>
 #include <mm/as.h>
+#include <mm/page.h>
 #include <synch/mutex.h>
 #include <syscall/copy.h>
@@ -52,4 +53,5 @@
 #include <errno.h>
 #include <trace.h>
+#include <bitops.h>
 
 /** This lock protects the parea_btree. */
@@ -87,25 +89,24 @@
 /** Map piece of physical memory into virtual address space of current task.
  *
- * @param pf    Physical address of the starting frame.
- * @param vp    Virtual address of the starting page.
+ * @param phys  Physical address of the starting frame.
  * @param pages Number of pages to map.
  * @param flags Address space area flags for the mapping.
- *
- * @return 0 on success, EPERM if the caller lacks capabilities to use this
- *         syscall, EBADMEM if pf or vf is not page aligned, ENOENT if there
- *         is no task matching the specified ID or the physical address space
- *         is not enabled for mapping and ENOMEM if there was a problem in
- *         creating address space area.
- *
- */
-NO_TRACE static int ddi_physmem_map(uintptr_t pf, uintptr_t vp, size_t pages,
-    unsigned int flags)
+ * @param virt  Virtual address of the starting page.
+ * @param bound Lowest virtual address bound.
+ *
+ * @return EOK on success.
+ * @return EPERM if the caller lacks capabilities to use this syscall.
+ * @return EBADMEM if phys is not page aligned.
+ * @return ENOENT if there is no task matching the specified ID or
+ *         the physical address space is not enabled for mapping.
+ * @return ENOMEM if there was a problem in creating address space area.
+ *
+ */
+NO_TRACE static int physmem_map(uintptr_t phys, size_t pages,
+    unsigned int flags, uintptr_t *virt, uintptr_t bound)
 {
 	ASSERT(TASK);
 	
-	if ((pf % FRAME_SIZE) != 0)
-		return EBADMEM;
-	
-	if ((vp % PAGE_SIZE) != 0)
+	if ((phys % FRAME_SIZE) != 0)
 		return EBADMEM;
 	
@@ -118,5 +119,5 @@
 	
 	mem_backend_data_t backend_data;
-	backend_data.base = pf;
+	backend_data.base = phys;
 	backend_data.frames = pages;
 	
@@ -129,5 +130,5 @@
 	btree_node_t *nodep;
 	parea_t *parea = (parea_t *) btree_search(&parea_btree,
-	    (btree_key_t) pf, &nodep);
+	    (btree_key_t) phys, &nodep);
 	
 	if ((parea != NULL) && (parea->frames >= pages)) {
@@ -149,5 +150,5 @@
 	
 	irq_spinlock_lock(&zones.lock, true);
-	size_t znum = find_zone(ADDR2PFN(pf), pages, 0);
+	size_t znum = find_zone(ADDR2PFN(phys), pages, 0);
 	
 	if (znum == (size_t) -1) {
@@ -182,6 +183,6 @@
 	
 map:
-	if (!as_area_create(TASK->as, flags, pages * PAGE_SIZE, vp,
-	    AS_AREA_ATTR_NONE, &phys_backend, &backend_data)) {
+	if (!as_area_create(TASK->as, flags, FRAMES2SIZE(pages),
+	    AS_AREA_ATTR_NONE, &phys_backend, &backend_data, virt, bound)) {
 		/*
 		 * The address space area was not created.
@@ -207,4 +208,44 @@
 }
 
+NO_TRACE static int physmem_unmap(uintptr_t virt)
+{
+	// TODO: implement unmap
+	return EOK;
+}
+
+/** Wrapper for SYS_PHYSMEM_MAP syscall.
+ *
+ * @param phys     Physical base address to map
+ * @param pages    Number of pages
+ * @param flags    Flags of newly mapped pages
+ * @param virt_ptr Destination virtual address
+ * @param bound    Lowest virtual address bound.
+ *
+ * @return 0 on success, otherwise it returns error code found in errno.h
+ *
+ */
+sysarg_t sys_physmem_map(uintptr_t phys, size_t pages, unsigned int flags,
+    void *virt_ptr, uintptr_t bound)
+{
+	uintptr_t virt = (uintptr_t) -1;
+	int rc = physmem_map(ALIGN_DOWN(phys, FRAME_SIZE), pages, flags,
+	    &virt, bound);
+	if (rc != EOK)
+		return rc;
+	
+	rc = copy_to_uspace(virt_ptr, &virt, sizeof(virt));
+	if (rc != EOK) {
+		physmem_unmap((uintptr_t) virt);
+		return rc;
+	}
+	
+	return EOK;
+}
+
+sysarg_t sys_physmem_unmap(uintptr_t virt)
+{
+	return physmem_unmap(virt);
+}
+
 /** Enable range of I/O space for task.
  *
@@ -217,6 +258,5 @@
  *
  */
-NO_TRACE static int ddi_iospace_enable(task_id_t id, uintptr_t ioaddr,
-    size_t size)
+NO_TRACE static int iospace_enable(task_id_t id, uintptr_t ioaddr, size_t size)
 {
 	/*
@@ -243,28 +283,8 @@
 	/* Lock the task and release the lock protecting tasks_btree. */
 	irq_spinlock_exchange(&tasks_lock, &task->lock);
-	
 	int rc = ddi_iospace_enable_arch(task, ioaddr, size);
-	
 	irq_spinlock_unlock(&task->lock, true);
 	
 	return rc;
-}
-
-/** Wrapper for SYS_PHYSMEM_MAP syscall.
- *
- * @param phys_base Physical base address to map
- * @param virt_base Destination virtual address
- * @param pages Number of pages
- * @param flags Flags of newly mapped pages
- *
- * @return 0 on success, otherwise it returns error code found in errno.h
- *
- */
-sysarg_t sys_physmem_map(sysarg_t phys_base, sysarg_t virt_base,
-    sysarg_t pages, sysarg_t flags)
-{
-	return (sysarg_t) ddi_physmem_map(ALIGN_DOWN((uintptr_t) phys_base,
-	    FRAME_SIZE), ALIGN_DOWN((uintptr_t) virt_base, PAGE_SIZE),
-	    (size_t) pages, (int) flags);
 }
 
@@ -283,8 +303,122 @@
 		return (sysarg_t) rc;
 	
-	return (sysarg_t) ddi_iospace_enable((task_id_t) arg.task_id,
+	return (sysarg_t) iospace_enable((task_id_t) arg.task_id,
 	    (uintptr_t) arg.ioaddr, (size_t) arg.size);
 }
 
+sysarg_t sys_iospace_disable(ddi_ioarg_t *uspace_io_arg)
+{
+	// TODO: implement
+	return ENOTSUP;
+}
+
+NO_TRACE static int dmamem_map(uintptr_t virt, size_t size, unsigned int map_flags,
+    unsigned int flags, void **phys)
+{
+	ASSERT(TASK);
+	
+	// TODO: implement locking of non-anonymous mapping
+	return page_find_mapping(virt, phys);
+}
+
+NO_TRACE static int dmamem_map_anonymous(size_t size, unsigned int map_flags,
+    unsigned int flags, void **phys, uintptr_t *virt, uintptr_t bound)
+{
+	ASSERT(TASK);
+	
+	size_t pages = SIZE2FRAMES(size);
+	uint8_t order;
+	
+	/* We need the 2^order >= pages */
+	if (pages == 1)
+		order = 0;
+	else
+		order = fnzb(pages - 1) + 1;
+	
+	*phys = frame_alloc_noreserve(order, 0);
+	if (*phys == NULL)
+		return ENOMEM;
+	
+	mem_backend_data_t backend_data;
+	backend_data.base = (uintptr_t) *phys;
+	backend_data.frames = pages;
+	
+	if (!as_area_create(TASK->as, map_flags, size,
+	    AS_AREA_ATTR_NONE, &phys_backend, &backend_data, virt, bound)) {
+		frame_free_noreserve((uintptr_t) *phys);
+		return ENOMEM;
+	}
+	
+	return EOK;
+}
+
+NO_TRACE static int dmamem_unmap(uintptr_t virt, size_t size)
+{
+	// TODO: implement unlocking & unmap
+	return EOK;
+}
+
+NO_TRACE static int dmamem_unmap_anonymous(uintptr_t virt)
+{
+	// TODO: implement unlocking & unmap
+	return EOK;
+}
+
+sysarg_t sys_dmamem_map(size_t size, unsigned int map_flags, unsigned int flags,
+    void *phys_ptr, void *virt_ptr, uintptr_t bound)
+{
+	if ((flags & DMAMEM_FLAGS_ANONYMOUS) == 0) {
+		/*
+		 * Non-anonymous DMA mapping
+		 */
+		
+		void *phys;
+		int rc = dmamem_map((uintptr_t) virt_ptr, size, map_flags,
+		    flags, &phys);
+		
+		if (rc != EOK)
+			return rc;
+		
+		rc = copy_to_uspace(phys_ptr, &phys, sizeof(phys));
+		if (rc != EOK) {
+			dmamem_unmap((uintptr_t) virt_ptr, size);
+			return rc;
+		}
+	} else {
+		/*
+		 * Anonymous DMA mapping
+		 */
+		
+		void *phys;
+		uintptr_t virt = (uintptr_t) -1;
+		int rc = dmamem_map_anonymous(size, map_flags, flags,
+		    &phys, &virt, bound);
+		if (rc != EOK)
+			return rc;
+		
+		rc = copy_to_uspace(phys_ptr, &phys, sizeof(phys));
+		if (rc != EOK) {
+			dmamem_unmap_anonymous((uintptr_t) virt);
+			return rc;
+		}
+		
+		rc = copy_to_uspace(virt_ptr, &virt, sizeof(virt));
+		if (rc != EOK) {
+			dmamem_unmap_anonymous((uintptr_t) virt);
+			return rc;
+		}
+	}
+	
+	return EOK;
+}
+
+sysarg_t sys_dmamem_unmap(uintptr_t virt, size_t size, unsigned int flags)
+{
+	if ((flags & DMAMEM_FLAGS_ANONYMOUS) == 0)
+		return dmamem_unmap(virt, size);
+	else
+		return dmamem_unmap_anonymous(virt);
+}
+
 /** @}
  */
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/ipc/irq.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -42,6 +42,6 @@
  *
  * The structure of a notification message is as follows:
- * - IMETHOD: interface and method as registered by the SYS_REGISTER_IRQ
- *            syscall
+ * - IMETHOD: interface and method as registered by
+ *            the SYS_IRQ_REGISTER syscall
  * - ARG1: payload modified by a 'top-half' handler
  * - ARG2: payload modified by a 'top-half' handler
@@ -365,26 +365,15 @@
 		return IRQ_DECLINE;
 	
-#define CMD_MEM_READ(target) \
-do { \
-	void *va = code->cmds[i].addr; \
-	if (AS != irq->driver_as) \
-		as_switch(AS, irq->driver_as); \
-	memcpy_from_uspace(&target, va, (sizeof(target))); \
-	if (dstarg) \
-		scratch[dstarg] = target; \
-} while(0)
-
-#define CMD_MEM_WRITE(val) \
-do { \
-	void *va = code->cmds[i].addr; \
-	if (AS != irq->driver_as) \
-		as_switch(AS, irq->driver_as); \
-	memcpy_to_uspace(va, &val, sizeof(val)); \
-} while (0)
-
 	as_t *current_as = AS;
-	size_t i;
-	for (i = 0; i < code->cmdcount; i++) {
+	if (current_as != irq->driver_as)
+		as_switch(AS, irq->driver_as);
+	
+	for (size_t i = 0; i < code->cmdcount; i++) {
 		uint32_t dstval;
+		void *va;
+		uint8_t val8;
+		uint16_t val16;
+		uint32_t val32;
+		
 		uintptr_t srcarg = code->cmds[i].srcarg;
 		uintptr_t dstarg = code->cmds[i].dstarg;
@@ -442,50 +431,56 @@
 			}
 			break;
-		case CMD_MEM_READ_8: {
-			uint8_t val;
-			CMD_MEM_READ(val);
-			break;
-			}
-		case CMD_MEM_READ_16: {
-			uint16_t val;
-			CMD_MEM_READ(val);
-			break;
-			}
-		case CMD_MEM_READ_32: {
-			uint32_t val;
-			CMD_MEM_READ(val);
-			break;
-			}
-		case CMD_MEM_WRITE_8: {
-			uint8_t val = code->cmds[i].value;
-			CMD_MEM_WRITE(val);
-			break;
-			}
-		case CMD_MEM_WRITE_16: {
-			uint16_t val = code->cmds[i].value;
-			CMD_MEM_WRITE(val);
-			break;
-			}
-		case CMD_MEM_WRITE_32: {
-			uint32_t val = code->cmds[i].value;
-			CMD_MEM_WRITE(val);
-			break;
-			}
+		case CMD_MEM_READ_8:
+			va = code->cmds[i].addr;
+			memcpy_from_uspace(&val8, va, sizeof(val8));
+			if (dstarg)
+				scratch[dstarg] = val8;
+			break;
+		case CMD_MEM_READ_16:
+			va = code->cmds[i].addr;
+			memcpy_from_uspace(&val16, va, sizeof(val16));
+			if (dstarg)
+				scratch[dstarg] = val16;
+			break;
+		case CMD_MEM_READ_32:
+			va = code->cmds[i].addr;
+			memcpy_from_uspace(&val32, va, sizeof(val32));
+			if (dstarg)
+				scratch[dstarg] = val32;
+			break;
+		case CMD_MEM_WRITE_8:
+			val8 = code->cmds[i].value;
+			va = code->cmds[i].addr;
+			memcpy_to_uspace(va, &val8, sizeof(val8));
+			break;
+		case CMD_MEM_WRITE_16:
+			val16 = code->cmds[i].value;
+			va = code->cmds[i].addr;
+			memcpy_to_uspace(va, &val16, sizeof(val16));
+			break;
+		case CMD_MEM_WRITE_32:
+			val32 = code->cmds[i].value;
+			va = code->cmds[i].addr;
+			memcpy_to_uspace(va, &val32, sizeof(val32));
+			break;
 		case CMD_MEM_WRITE_A_8:
 			if (srcarg) {
-				uint8_t val = scratch[srcarg];
-				CMD_MEM_WRITE(val);
+				val8 = scratch[srcarg];
+				va = code->cmds[i].addr;
+				memcpy_to_uspace(va, &val8, sizeof(val8));
 			}
 			break;
 		case CMD_MEM_WRITE_A_16:
 			if (srcarg) {
-				uint16_t val = scratch[srcarg];
-				CMD_MEM_WRITE(val);
+				val16 = scratch[srcarg];
+				va = code->cmds[i].addr;
+				memcpy_to_uspace(va, &val16, sizeof(val16));
 			}
 			break;
 		case CMD_MEM_WRITE_A_32:
 			if (srcarg) {
-				uint32_t val = scratch[srcarg];
-				CMD_MEM_WRITE(val);
+				val32 = scratch[srcarg];
+				va = code->cmds[i].addr;
+				memcpy_to_uspace(va, &val32, sizeof(val32));
 			}
 			break;
@@ -513,4 +508,5 @@
 		}
 	}
+	
 	if (AS != current_as)
 		as_switch(AS, current_as);
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/ipc/sysipc.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -271,19 +271,27 @@
 			irq_spinlock_unlock(&answer->sender->lock, true);
 			
+			uintptr_t dst_base = (uintptr_t) -1;
 			int rc = as_area_share(as, IPC_GET_ARG1(*olddata),
-			    IPC_GET_ARG2(*olddata), AS,
-			    IPC_GET_ARG1(answer->data), IPC_GET_ARG3(*olddata));
+			    IPC_GET_ARG2(*olddata), AS, IPC_GET_ARG3(*olddata),
+			    &dst_base, IPC_GET_ARG1(answer->data));
+			
+			if (rc == EOK)
+				rc = copy_to_uspace((void *) IPC_GET_ARG2(answer->data),
+				    &dst_base, sizeof(dst_base));
+			
 			IPC_SET_RETVAL(answer->data, rc);
 			return rc;
 		}
 	} else if (IPC_GET_IMETHOD(*olddata) == IPC_M_SHARE_IN) {
-		if (!IPC_GET_RETVAL(answer->data)) { 
+		if (!IPC_GET_RETVAL(answer->data)) {
 			irq_spinlock_lock(&answer->sender->lock, true);
 			as_t *as = answer->sender->as;
 			irq_spinlock_unlock(&answer->sender->lock, true);
 			
+			uintptr_t dst_base = (uintptr_t) -1;
 			int rc = as_area_share(AS, IPC_GET_ARG1(answer->data),
-			    IPC_GET_ARG2(*olddata), as, IPC_GET_ARG1(*olddata),
-			    IPC_GET_ARG2(answer->data));
+			    IPC_GET_ARG1(*olddata), as, IPC_GET_ARG2(answer->data),
+			    &dst_base, IPC_GET_ARG3(answer->data));
+			IPC_SET_ARG4(answer->data, dst_base);
 			IPC_SET_RETVAL(answer->data, rc);
 		}
@@ -1185,5 +1193,5 @@
  *
  */
-sysarg_t sys_register_irq(inr_t inr, devno_t devno, sysarg_t imethod,
+sysarg_t sys_irq_register(inr_t inr, devno_t devno, sysarg_t imethod,
     irq_code_t *ucode)
 {
@@ -1202,5 +1210,5 @@
  *
  */
-sysarg_t sys_unregister_irq(inr_t inr, devno_t devno)
+sysarg_t sys_irq_unregister(inr_t inr, devno_t devno)
 {
 	if (!(cap_get(TASK) & CAP_IRQ_REG))
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/lib/elf.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -226,6 +226,6 @@
 	size_t mem_sz = entry->p_memsz + (entry->p_vaddr - base);
 	
-	as_area_t *area = as_area_create(as, flags, mem_sz, base,
-	    AS_AREA_ATTR_NONE, &elf_backend, &backend_data);
+	as_area_t *area = as_area_create(as, flags, mem_sz,
+	    AS_AREA_ATTR_NONE, &elf_backend, &backend_data, &base, 0);
 	if (!area)
 		return EE_MEMORY;
Index: kernel/generic/src/lib/ra.c
===================================================================
--- kernel/generic/src/lib/ra.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/generic/src/lib/ra.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,431 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+
+/**
+ * @file
+ * @brief Resource allocator.
+ *
+ * This is a generic resource allocator, loosely based on the ideas presented
+ * in chapter 4 of the following paper and further simplified:
+ *
+ *   Bonwick J., Adams J.: Magazines and Vmem: Extending the Slab Allocator to
+ *   Many CPUs and Arbitrary Resources, USENIX 2001
+ *
+ */
+
+#include <lib/ra.h>
+#include <typedefs.h>
+#include <mm/slab.h>
+#include <bitops.h>
+#include <debug.h>
+#include <panic.h>
+#include <adt/list.h>
+#include <adt/hash_table.h>
+#include <align.h>
+#include <macros.h>
+#include <synch/spinlock.h>
+
+static slab_cache_t *ra_segment_cache;
+
+#define USED_BUCKETS	1024
+
+static size_t used_hash(sysarg_t *key)
+{
+	return ((*key >> 2) & (USED_BUCKETS - 1));
+}
+
+static bool used_compare(sysarg_t *key, size_t keys, link_t *item)
+{
+	ra_segment_t *seg;
+
+	seg = hash_table_get_instance(item, ra_segment_t, fu_link);
+	return seg->base == *key;
+}
+
+static hash_table_operations_t used_ops = {
+	.hash = used_hash,
+	.compare = used_compare,
+	.remove_callback = NULL,
+};
+
+/** Calculate the segment size. */
+static size_t ra_segment_size_get(ra_segment_t *seg)
+{
+	ra_segment_t *nextseg;
+
+	nextseg = list_get_instance(seg->segment_link.next, ra_segment_t,
+	    segment_link);
+	return nextseg->base - seg->base;
+}
+
+static ra_segment_t *ra_segment_create(uintptr_t base)
+{
+	ra_segment_t *seg;
+
+	seg = slab_alloc(ra_segment_cache, FRAME_ATOMIC);
+	if (!seg)
+		return NULL;
+
+	link_initialize(&seg->segment_link);
+	link_initialize(&seg->fu_link);
+
+	seg->base = base;
+	seg->flags = 0;
+
+	return seg;
+}
+
+static void ra_segment_destroy(ra_segment_t *seg)
+{
+	slab_free(ra_segment_cache, seg);
+}
+
+static ra_span_t *ra_span_create(uintptr_t base, size_t size)
+{
+	ra_span_t *span;
+	ra_segment_t *seg, *lastseg;
+	unsigned int i;
+
+	span = (ra_span_t *) malloc(sizeof(ra_span_t), FRAME_ATOMIC);
+	if (!span)
+		return NULL;
+
+	span->max_order = fnzb(size);
+	span->base = base;
+	span->size = size;
+
+	span->free = (list_t *) malloc((span->max_order + 1) * sizeof(list_t),
+	    FRAME_ATOMIC);
+	if (!span->free) {
+		free(span);
+		return NULL;
+	}
+
+	/*
+	 * Create a segment to represent the entire size of the span.
+	 */
+	seg = ra_segment_create(base);
+	if (!seg) {
+		free(span->free);
+		free(span);
+		return NULL;
+	}
+	seg->flags = RA_SEGMENT_FREE;
+
+	/*
+	 * The last segment will be used as a sentinel at the end of the
+	 * segment list so that it is possible to calculate the size for
+	 * all other segments. It will not be placed in any free list or
+	 * in the used segment hash and adjacent segments will not be
+	 * coalesced with it.
+	 */
+	lastseg = ra_segment_create(base + size);
+	if (!lastseg) {
+		ra_segment_destroy(seg);
+		free(span->free);
+		free(span);
+		return NULL;
+	}
+
+	link_initialize(&span->span_link);
+	list_initialize(&span->segments);
+
+	hash_table_create(&span->used, USED_BUCKETS, 1, &used_ops);
+
+	for (i = 0; i <= span->max_order; i++)
+		list_initialize(&span->free[i]);
+
+	/* Insert the first segment into the list of segments. */
+	list_append(&seg->segment_link, &span->segments);
+	/* Insert the last segment into the list of segments. */
+	list_append(&lastseg->segment_link, &span->segments);
+
+	/* Insert the first segment into the respective free list. */
+	list_append(&seg->fu_link, &span->free[span->max_order]);
+
+	return span;
+}
+
+/** Create an empty arena. */
+ra_arena_t *ra_arena_create(void)
+{
+	ra_arena_t *arena;
+
+	arena = (ra_arena_t *) malloc(sizeof(ra_arena_t), FRAME_ATOMIC);
+	if (!arena)
+		return NULL;
+
+	spinlock_initialize(&arena->lock, "arena_lock");
+	list_initialize(&arena->spans);
+
+	return arena;
+}
+
+/** Add a span to arena. */
+bool ra_span_add(ra_arena_t *arena, uintptr_t base, size_t size)
+{
+	ra_span_t *span;
+
+	/*
+	 * At the moment, we can only create resources that don't include 0.
+	 * If 0 needs to be considered as a valid resource, we would need to
+	 * slightly change the API of the resource allocator.
+	 */
+	if (base == 0)
+		return false;
+
+	span = ra_span_create(base, size);
+	if (!span)
+		return false;
+
+	/* TODO: check for overlaps */
+	spinlock_lock(&arena->lock);
+	list_append(&span->span_link, &arena->spans);
+	spinlock_unlock(&arena->lock);
+	return true;
+}
+
+static uintptr_t ra_span_alloc(ra_span_t *span, size_t size, size_t align)
+{
+	/*
+	 * We need to add the maximum of align - 1 to be able to compensate for
+	 * the worst case unaligned segment.
+	 */
+	size_t needed = size + align - 1;
+	size_t order = ispwr2(needed) ? fnzb(needed) : fnzb(needed) + 1;
+	ra_segment_t *pred = NULL;
+	ra_segment_t *succ = NULL;
+
+	/*
+	 * Find the free list of the smallest order which can satisfy this
+	 * request.
+	 */
+	for (; order <= span->max_order; order++) {
+		ra_segment_t *seg;
+		uintptr_t newbase;
+
+		if (list_empty(&span->free[order]))
+			continue;
+
+		/* Take the first segment from the free list. */
+		seg = list_get_instance(list_first(&span->free[order]),
+		    ra_segment_t, fu_link);
+
+		ASSERT(seg->flags & RA_SEGMENT_FREE);
+
+		/*
+		 * See if we need to allocate new segments for the chopped-off
+		 * parts of this segment.
+		 */
+		if (!IS_ALIGNED(seg->base, align)) {
+			pred = ra_segment_create(seg->base);
+			if (!pred) {
+				/*
+				 * Fail as we are unable to split the segment.
+				 */
+				break;
+			}
+			pred->flags |= RA_SEGMENT_FREE;
+		}
+		newbase = ALIGN_UP(seg->base, align);
+		if (newbase + size != seg->base + ra_segment_size_get(seg)) {
+			ASSERT(newbase + (size - 1) < seg->base +
+			    (ra_segment_size_get(seg) - 1));
+			succ = ra_segment_create(newbase + size);
+			if (!succ) {
+				if (pred)
+					ra_segment_destroy(pred);
+				/*
+				 * Fail as we are unable to split the segment.
+				 */
+				break;
+			}
+			succ->flags |= RA_SEGMENT_FREE;
+		}
+		
+	
+		/* Put unneeded parts back. */
+		if (pred) {
+			size_t pred_order;
+
+			list_insert_before(&pred->segment_link,
+			    &seg->segment_link);
+			pred_order = fnzb(ra_segment_size_get(pred));
+			list_append(&pred->fu_link, &span->free[pred_order]);
+		}
+		if (succ) {
+			size_t succ_order;
+
+			list_insert_after(&succ->segment_link,
+			    &seg->segment_link);
+			succ_order = fnzb(ra_segment_size_get(succ));
+			list_append(&succ->fu_link, &span->free[succ_order]);
+		}
+
+		/* Now remove the found segment from the free list. */
+		list_remove(&seg->fu_link);
+		seg->base = newbase;
+		seg->flags &= ~RA_SEGMENT_FREE;
+
+		/* Hash-in the segment into the used hash. */
+		sysarg_t key = seg->base;
+		hash_table_insert(&span->used, &key, &seg->fu_link);
+
+		return newbase;
+	}
+
+	return 0;
+}
+
+static void ra_span_free(ra_span_t *span, size_t base, size_t size)
+{
+	sysarg_t key = base;
+	link_t *link;
+	ra_segment_t *seg;
+	ra_segment_t *pred;
+	ra_segment_t *succ;
+	size_t order;
+
+	/*
+	 * Locate the segment in the used hash table.
+	 */
+	link = hash_table_find(&span->used, &key);
+	if (!link) {
+		panic("Freeing segment which is not known to be used (base=%"
+		    PRIxn ", size=%" PRIdn ").", base, size);
+	}
+	seg = hash_table_get_instance(link, ra_segment_t, fu_link);
+
+	/*
+	 * Hash out the segment.
+	 */
+	hash_table_remove(&span->used, &key, 1);
+
+	ASSERT(!(seg->flags & RA_SEGMENT_FREE));
+	ASSERT(seg->base == base);
+	ASSERT(ra_segment_size_get(seg) == size);
+
+	/*
+	 * Check whether the segment can be coalesced with its left neighbor.
+	 */
+	if (list_first(&span->segments) != &seg->segment_link) {
+		pred = hash_table_get_instance(seg->segment_link.prev,
+		    ra_segment_t, segment_link);
+
+		ASSERT(pred->base < seg->base);
+
+		if (pred->flags & RA_SEGMENT_FREE) {
+			/*
+			 * The segment can be coalesced with its predecessor.
+			 * Remove the predecessor from the free and segment
+			 * lists, rebase the segment and throw the predecessor
+			 * away.
+			 */
+			list_remove(&pred->fu_link);
+			list_remove(&pred->segment_link);
+			seg->base = pred->base;
+			ra_segment_destroy(pred);
+		}
+	}
+
+	/*
+	 * Check whether the segment can be coalesced with its right neighbor.
+	 */
+	succ = hash_table_get_instance(seg->segment_link.next, ra_segment_t,
+	    segment_link);
+	ASSERT(succ->base > seg->base);
+	if (succ->flags & RA_SEGMENT_FREE) {
+		/*
+		 * The segment can be coalesced with its successor.
+		 * Remove the successor from the free and segment lists
+		 * and throw it away.
+		 */
+		list_remove(&succ->fu_link);
+		list_remove(&succ->segment_link);
+		ra_segment_destroy(succ);
+	}
+
+	/* Put the segment on the appropriate free list. */
+	seg->flags |= RA_SEGMENT_FREE;
+	order = fnzb(ra_segment_size_get(seg));
+	list_append(&seg->fu_link, &span->free[order]);
+}
+
+/** Allocate resources from arena. */
+uintptr_t ra_alloc(ra_arena_t *arena, size_t size, size_t alignment)
+{
+	uintptr_t base = 0;
+
+	ASSERT(size >= 1);
+	ASSERT(alignment >= 1);
+	ASSERT(ispwr2(alignment));
+
+	spinlock_lock(&arena->lock);
+	list_foreach(arena->spans, cur) {
+		ra_span_t *span = list_get_instance(cur, ra_span_t, span_link);
+
+		base = ra_span_alloc(span, size, alignment);
+		if (base)
+			break;
+	}
+	spinlock_unlock(&arena->lock);
+
+	return base;
+}
+
+/* Return resources to arena. */
+void ra_free(ra_arena_t *arena, uintptr_t base, size_t size)
+{
+	spinlock_lock(&arena->lock);
+	list_foreach(arena->spans, cur) {
+		ra_span_t *span = list_get_instance(cur, ra_span_t, span_link);
+
+		if (iswithin(span->base, span->size, base, size)) {
+			ra_span_free(span, base, size);
+			spinlock_unlock(&arena->lock);
+			return;
+		}
+	}
+	spinlock_unlock(&arena->lock);
+
+	panic("Freeing to wrong arena (base=%" PRIxn ", size=%" PRIdn ").",
+	    base, size);
+}
+
+void ra_init(void)
+{
+	ra_segment_cache = slab_cache_create("segment_cache",
+	    sizeof(ra_segment_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
+}
+
+/** @}
+ */
Index: kernel/generic/src/lib/rd.c
===================================================================
--- kernel/generic/src/lib/rd.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/src/lib/rd.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -54,5 +54,5 @@
 void init_rd(void *data, size_t size)
 {
-	uintptr_t base = KA2PA((uintptr_t) data);
+	uintptr_t base = (uintptr_t) data;
 	ASSERT((base % FRAME_SIZE) == 0);
 	
